#!/usr/bin/osascript

on run argv
	
	set cwd to do shell script "pwd"
	
	set cmd to "cd " & quoted form of cwd & ";"
	set i to 0
	repeat with arg in argv
		# Ignore any initial -e argument (arg = "-e" doesn't work for some
		# reason)
		if i = 0 and arg contains "-e" then
			# do nothing
		else
			set arg to quoted form of arg
			set cmd to cmd & " " & arg
		end if
		
		set i to i + 1
	end repeat
	
	set console_tab to my find_console_tab()
	
	tell application "Terminal"
		activate
		do script cmd in console_tab
	end tell
end run

on find_console_tab()
	tell application "Terminal"
		repeat with win in every window
			try
				set tab_list to every tab of win
			on error errmsg
				set tab_list to missing value
			end try
			
			if tab_list is not equal to missing value then
				repeat with t in tab_list
					
					if (custom title of t) contains "Wing Debug Console" then
						if not (busy of t) then
							return t
						end if
					end if
				end repeat
			end if
		end repeat
		
		set new_window to do script
		set custom title of new_window to "Wing Debug Console"
		return new_window
	end tell
end find_console_tab