#########################################################################
""" py3utils.py -- Utilities that run only under Python 3.x

Copyright (c) 1999-2012, Archaeopteryx Software, Inc.  All rights reserved.

Written by Stephan R.A. Deibel and John P. Ehresman

"""
#########################################################################

# This file should contain only code that can't be written so that
# it works both under Python 2.x and 3.x

import types as _types

def doprint(*args):
  print(*args)
  
def has_key(o, key):
  return key in o

def get_unicode_str(x):
  return x

def instancemethod(cb, cl):
  return _types.MethodType(cb, cl)

def makemodule(name):
  return _types.ModuleType(name)

def iscallable(x):
  return hasattr(x, '__call__')

def datajoin(d):
  return b''.join(d)

def make_xrange(start, end):
  return range(start, end)

def make_bytes(s):
  return bytes(s, 'ascii')

def apply(f, args, kw=None):
  if kw is not None:
    return f(*args, **kw)
  else:
    return f(*args)

# Used only in Python 3 and hidden here to avoid wigging out Python 2.1,
# which reports nested scope syntax warning
def make_log_replacement(outer_self):
  def error(self, msg, *args, **kw):
    return outer_self._LogErrorReplacement(self, msg, *args, **kw)
  return error

