#########################################################################
""" __init__.py -- Shared implementation utilities for Wing IDE

Copyright (c) 1999-2012, Archaeopteryx Software, Inc.  All rights reserved.

Written by Stephan R.A. Deibel and John P. Ehresman

"""
#########################################################################


__all__ = [ 'callutils', 'datatype', 'destroyable', 'gsignal',  
            'guidefn', 'history', 'instancemgr', 'location', 'memprofile', 'mime',
            'pyvalwriter', 'reflect', 'ro_attrib', 'search', 'searchops',
            'spawn', 'statops', 'synch', 'textio', 'textutils', 'treecontroller',
            'typecheck', 'formbuilder', 'winmgr', 'dialogs', 'widgets',
            'fileattribmgr', 'savable', 'recent']

def _GetDynPackagePath():
	""" Generate a path to lookup modules in this package so the 
	cython-compiled is searched if the modules were compiled for
	the version & build of python this code is run in.
	"""
	
	import sys
	import os.path

	dirname = os.path.dirname(__file__)
	cycompiled = os.path.join(dirname, 'cython-compiled')

	stamp_file = os.path.join(cycompiled, 'python%d.%d' % sys.version_info[:2])
	if hasattr(sys, 'getobjects'):
		stamp_file += '-debug'
	else:
		stamp_file += '-release'

	path = [dirname]
	if os.path.exists(stamp_file):
		path.insert(0, cycompiled)
		
	return path

__path__ = _GetDynPackagePath()
